<?php
///////////////////////////////////////////
// Obtain data of the nodes
///////////////////////////////////////////

// Instance easybitcoin
require_once 'easybitcoin.php';

// return header json.
header('Content-type: application/json');
$node = "";
error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - Iniciando data.php\r\n", 3, "/tmp/data.log");

// take the node from GET parameter
if (!isset($_GET["node"]))
{
	echo "{ }";
	die;
}
else
{
	$node = $_GET["node"];
}

$ch = curl_init();

// Query to containers API about the node
$query = "http://127.0.0.1:2375/v1.25/containers/" . $node . "/json";
error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - Query docker : [" . $query . "]\r\n", 3, "/tmp/data.log");

// Configure curl request
curl_setopt($ch, CURLOPT_URL, $query);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
// $output contains the output string
$output = curl_exec($ch);
error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - Error curl : [" . curl_errno($ch) . "]\r\n", 3, "/tmp/data.log");
error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - Status curl : [" . curl_getinfo($ch,CURLINFO_HTTP_CODE) . "]\r\n", 3, "/tmp/data.log");
error_log("[" . date("m.d.y") . "-" . date("H:i:s") . "] - Error curl : [" . curl_errno($ch) . "]\r\n", 3, "/tmp/data.log");
curl_close($ch);
$containers = json_decode($output, true);
// call to easybitcoin with the IPAddress
$ipAddress = $containers["NetworkSettings"]["IPAddress"];
$bitcoin = new Bitcoin('statoshidockerized', 'prueba', $ipAddress, '8332');
// Get info about the node
$bitcoin->getinfo();
$response = $bitcoin->response;
$response = $response['result'];

// get Keypoolsize, payxfee, relayfee, blocks, getblockcount, getconnectioncount listaddressgrouping
$keypoolsize = $response["keypoolsize"];
$paytxfee = $response["paytxfee"];
$relayfee = $response["relayfee"];
$blocks = $response["blocks"];
$bitcoin->getblockcount();
$response = $bitcoin->response;
$response = $response['result'];

$bitcoin->getconnectioncount();
$response = $bitcoin->response;
$response = $response['result'];

$bitcoin->listaddressgroupings();
$response = $bitcoin->response;
$response = $response['result'];

//Return json structure with the data.
echo "{\"ip\":\"" . $ipAddress . "\", \"blocks\":\"" . $blocks . "\", \"keypoolsize\":\"" . $keypoolsize ."\", \"paytxfee\":\"" . $paytxfee . "\", \"relayfee\": \"" . $relayfee . "\"}";
?>
