<?php
///////////////////////////////////////////
// Create network Json Structure
///////////////////////////////////////////

// Instance easybitcoin
require_once 'easybitcoin.php';

// return header json.
header('Content-Type: application/json');

// take the node from GET parameter
if (!isset($_GET["network"]))
{
	$network="walletreg";
}
else
{
	$network = $_GET["network"];
}

$arrNodes=array();
$arrEdges=array();
$arrNames=array();
$ch = curl_init();

// request all containers from containers API
$query = "http://127.0.0.1:2375/v1.25/containers/json?all=1";

curl_setopt($ch, CURLOPT_URL, $query);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

// $output contains the output string
$output = curl_exec($ch);
curl_close($ch);

// Decode json response
$containers = json_decode($output, true);

// Manage each node
foreach ($containers as $key => $value)
{
	$show = false;
	$name = "";
	$Id = "";
	$state = "";
    $IPAdress = "";
	// Search in the json structure
	foreach ($value as $k1 =>$v1)
	{ 
		if ($k1 == "Id")
		{
			$Id = $v1;
		}
		if ($k1 == "State")
		{
			$state = $v1;
		}
		// Obtain the name of the nodes
		if ($k1 == "Names")
		{
			foreach ($v1 as $keyName => $valueName)
			{
				$pos = strpos($valueName, $network);
				if($pos != false || $pos == 1)
				{
					$name = substr($valueName, 1);
					$show = true;
				}
			}
		}
		//obtain IPAddress of the node 
		if ($k1 == "NetworkSettings")
		{
			$networks = $v1;
			$ipAddress = $networks['Networks']['bridge']['IPAddress'];
		}
	}
	if ($show)
	{
	   $arrNames[$ipAddress] = $name;
		$pos = array_search($ipAddress . ":ext", $arrNodes);
		if($pos != false)
		{ 
			$arrNodes[$pos] = $ipAddress . ":int";
		}
		else
		{
			$arrNodes[] = $ipAddress . ":int";
		}
	
	   // Call to getpeerinfo method in order to obtain the peers connected to the node.
       $bitcoin = new Bitcoin('statoshidockerized', 'prueba', $ipAddress, '8332');
	   $bitcoin->getpeerinfo();
	   $response = $bitcoin->response;
 	   $response = $response['result'];
	   if(count($response) > 0)
	   {
		foreach ($response as $key => $value)
		{		
			$ip = "";
			$endip = strpos($value['addr'], ":");
			if ($endip != false)
			{
				$ip = substr($value['addr'], 0, $endip);
			}
			else
			{
				$ip = $value['addr'];
			}
			if ($ip != "")
			{
				if(array_search($ip . ":ext", $arrNodes) === false && array_search($ip . ":int", $arrNodes) === false)
				{ 
					$arrNodes[] =$ip .":ext";
				}
				$arrEdges[] = $ipAddress . ":" . $ip;
				
			}		
		}
	   }
	}	
}
echo "{\"nodes\": [";
for($index=0;$index<count($arrNodes);$index++)
{
      if($index > 0)
      {
            echo  ",";
      }
      $firstTab = strpos($arrNodes[$index],":")+1;
      $type = substr($arrNodes[$index], $firstTab);
      $ip = substr($arrNodes[$index], 0, strpos($arrNodes[$index],":"));      
      if ($type == "int")
      {
      	echo "{\"id\": \"" . $ip . "\",\"label\": \"" . $arrNames[$ip] . "\", ";
      	echo "\"x\": " . rand(0,10) . ", \"y\": " . rand(1,10) . ", \"size\": 3, \"color\": \"#FFF\"}";
      }
      else
      {
      	echo "{\"id\": \"" . $ip ."\",\"label\": \"" . $ip . "\",";
      	echo "\"x\": " . rand(0,10) . ", \"y\": " . rand(1,10) . ", \"size\": 3, \"color\": \"#F11\"}";

      }
}
echo "], \"edges\":[";
for($index=0;$index<count($arrEdges);$index++)
{
      if($index > 0)
      {
            echo  ",";
      }
      $ip1 = substr($arrEdges[$index], 0, strpos($arrEdges[$index],":"));
      $ip2 = substr($arrEdges[$index], strpos($arrEdges[$index],":")+1);
      echo "{\"id\": \"e" . $index . "\", \"source\": \"" . $ip1 . "\", \"target\": \"" . $ip2 . "\"}";     
}
echo "]}";
?>
